void SoftMax7219Init(char CodeB, char Intensity, char ScanLimit, char ShutDown)
{
  MAX7219_CS=1;
  MAX7219_SDO=0;
  MAX7219_SDI=0;
  MAX7219_SCK=0;
  MAX7219_CS_DIRECTION=0;
  MAX7219_SDO_DIRECTION=0;
  MAX7219_SDI_DIRECTION=1;
  MAX7219_SCK_DIRECTION=0;
  
  MAX7219_CS=1;

  MAX7219_CS=0;
  Soft7219SpiWriteByte(0x09);
  Soft7219SpiWriteByte(CodeB);
  MAX7219_CS=1;

  MAX7219_CS=0;
  Soft7219SpiWriteByte(0x0a);
  Soft7219SpiWriteByte(Intensity);
  MAX7219_CS=1;

  MAX7219_CS=0;
  Soft7219SpiWriteByte(0x0b);//----> scan limit register
  Soft7219SpiWriteByte(ScanLimit);//----> Displays 0-3 segments
  MAX7219_CS=1;

  MAX7219_CS=0;
  Soft7219SpiWriteByte(0x0c);
  Soft7219SpiWriteByte(ShutDown);
  MAX7219_CS=1;

  MAX7219_CS=0;
  Soft7219SpiWriteByte(0x00);
  Soft7219SpiWriteByte(0xff);
  MAX7219_CS=1;
}

void SoftMax7219Print(unsigned long Number, unsigned short NumberOfDigits)
{
  short i;
  for(i=1;Number>0||i-NumberOfDigits<=0;Number/=10,i++)
  {
    MAX7219_CS=0;
    Soft7219SpiWriteByte(i);
    Soft7219SpiWriteByte(Number%10);
    MAX7219_CS=1;
  }
}


void SoftMax7219DisplayOff()
{
  MAX7219_CS=0;
  Soft7219SpiWriteByte(0x0c);
  Soft7219SpiWriteByte(0x00);
  MAX7219_CS=1;
}

void SoftMax7219DisplayOn()
{
  MAX7219_CS=0;
  Soft7219SpiWriteByte(0x0c);
  Soft7219SpiWriteByte(0x01);
  MAX7219_CS=1;
}

void SoftMax7219UpdateIntensity(char OnValue)
{
  if(OnValue>=0&&OnValue<=15)
  {
    MAX7219_CS=0;
    Soft7219SpiWriteByte(0x0a);
    Soft7219SpiWriteByte(OnValue);
    MAX7219_CS=1;
  }
}